#include "limits.h"

/*@ ensures Rightmost: \forall integer k; \result < k < size
==> tab[k] != value;
ensures Value: tab[\result] == value || \result == size;
*/
unsigned int find_last(int *tab, int value, unsigned int size)
{
    unsigned int i = 0;
    unsigned int pos = size;
    while (i < size)
    {
        if (tab[i] == value)
            pos = i;
        i++;
    }
    return pos;
}

/*@ ensures Rightmost: \forall integer k; \result < k < size
==> tab[k] != value;
ensures Value: tab[\result] == value || \result == size;
*/
unsigned int find_last_wrong(int *tab, int value, unsigned int size)
{
    return size;
}